from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger

##############################################################################

def paginate(objs, page, count=50):
	paginator = Paginator(objs, count)
	try:
		objs = paginator.page(page)
	except PageNotAnInteger:
		# If page is not an integer, deliver first page.
		objs = paginator.page(1)
	except EmptyPage:
		# If page is out of range (e.g. 9999), deliver last page of results.
		objs = paginator.page(paginator.num_pages)

	return objs

